// TableCalc.c  -*- c++ -*-  Time-stamp: <2008/03/23>
// (C) 2005-2008 HAL <http://hal9.blog3.fc2.com> HAL.Kinosita@gmail.com

// GPL ɊÂC̃\[XR[h̎gpCρCĔzz͎RłB

//////////////////////////////////////////////////////////////////////////////////////////
// TableCalc, creator ID = 'hCal' , type = 'appl'
// 񂾂̕\vZ\tg݂Ȃ́B̐Ƃ̌ʂ𓯎ɈB
// p(HSnetwork) Windows Av GridCalculator  PalmOS łgč́B
// 
// rh@ Makefile QƁB
// ̃t@C Emacs(Meadow) ŕҏWB^u 2 ɂȂƕ\邩B
//////////////////////////////////////////////////////////////////////////////////////////
#include <PalmOS.h>
#include <FrmGlue.h>
//#include <palmOne_68K.h>

#include <common/system/HsExtCommon.h> //FtrGet(hsFtrCreator, hsFtrIDVersion, &ftrVal)

#include "MathLib.h"

#include "TableCalc.h"
#include "TableCalc_rsc.h"


//=====================================================================================================================
//--- MathLib nhO
extern UInt16 MathLibRef; // defined in "MathLib.c"

UInt16 MyMathLibOpen(void) MSEG2;
UInt16 MyMathLibOpen(void){
	UInt16 cErr;

	cErr = SysLibLoad(sysFileTLibrary, MathLibCreator, &MathLibRef);
	if(cErr){ /*G[*/ 
		MemHandle mhStr = DmGet1Resource('tSTR', SrID_MLErrNotFound);
		if(mhStr != NULL){ ErrFatalDisplayIf(cErr, (Char*)MemHandleLock(mhStr)); MemHandleUnlock(mhStr); mhStr = NULL; }
		MathLibRef = NULL; 
		return cErr; 
	}

	cErr = MathLibOpen(MathLibRef, MathLibVersion);
	if(cErr){
		MemHandle mhStr = DmGet1Resource('tSTR', SrID_MLErrFailOpen);
		if(mhStr != NULL){ ErrFatalDisplayIf(cErr, (Char*)MemHandleLock(mhStr)); MemHandleUnlock(mhStr); mhStr = NULL; }
	}

	return cErr;
}

UInt16 MyMathLibClose(void) MSEG2;
UInt16 MyMathLibClose(void){
	UInt16 cErr, usecount;

	if(!MathLibRef) return errNone;

	cErr = MathLibClose(MathLibRef, &usecount);
	if(cErr){
		MemHandle mhStr = DmGet1Resource('tSTR', SrID_MLErrFailOpen);
		if(mhStr != NULL){ ErrFatalDisplayIf(cErr, (Char*)MemHandleLock(mhStr)); MemHandleUnlock(mhStr); mhStr = NULL; }
	}

	if(usecount == 0)
		SysLibRemove(MathLibRef); 

	return cErr;
}


//=====================================================================================================================
//--- vt@X̃Z[u^[h
void savePref_TableCalc(TableCalcPref_t* pPref){
	UInt16 prefSz = sizeof(TableCalcPref_t);
	if(pPref == NULL) return;
	PrefSetAppPreferences(TableCalc_CrtrID1q, TableCalc_PrefID_Base, TableCalc_PrefVer05b, pPref, prefSz, TableCalc_IsSavedPref);
}

void loadPref_TableCalc(TableCalcPref_t* pPref){
	UInt16 prefSz = sizeof(TableCalcPref_t);
	Int16 sPrefVerNo;
	if(pPref == NULL) return;

	sPrefVerNo = PrefGetAppPreferences(TableCalc_CrtrID1q, TableCalc_PrefID_Base, pPref, &prefSz, TableCalc_IsSavedPref);

	switch(sPrefVerNo){
		case TableCalc_PrefVer05b: //--- ݂̃o[W̓ǂݍݐȂC
			return;               // ɏIB

		default:                //--- `Ȃ珉
			//-Â̂
			if(sPrefVerNo != noPreferenceFound){
				PrefSetAppPreferences(TableCalc_CrtrID1q, TableCalc_PrefID_Base       , TableCalc_PrefVer05b, NULL, 0, TableCalc_IsSavedPref);
			}
			//-
			pPref->gAtrb.all = 0x00;
			pPref->gAtrb.is.RememberLastPos = true;
			pPref->gAtrb.is.SwapAlphaNum    = false; //true;
			pPref->gAtrb.is.UnitDegree      = true;
			pPref->gAtrb.is.ShowFmtPrfx     = true;
			pPref->gAtrb.is.UseVarOnOtherPg = true;
			pPref->cDispPage = 0;
			pPref->cDispRows = MaxDispRow;
			pPref->dblClkMs  = 300;
			//pPref->cWid_Name = 25;
			//pPref->cWid__Ans = 55;
			//pPref->cWid_Expr = 68;
			pPref->ansFmt    = AF_f;
			pPref->ansDig    = 8;//MaxAnsDig;
			StrCopy(pPref->strDelim, "\t");
			pPref->col.nameLeft  = Default_nameLeft;
			pPref->col.nameWidth = Default_nameWidth;
			pPref->col.ansLeft   = pPref->col.nameLeft + pPref->col.nameWidth + 1;
			pPref->col.ansWidth  = Default_ansWidth;
			pPref->col.exprLeft  = pPref->col.ansLeft  + pPref->col.ansWidth  + SpcBtAnsFld;
			//pPref->col.exprWidth = MaxScrX - pPref->col.exprLeft - FldSclWid +2; //+2 ͏XN[o[ɃI[o[bv邽
			pPref->col.exprWidth = MaxScrX - pPref->col.exprLeft - ExprRghtMrgn;
			pPref->maxFldExpnd = 3;
			{
				RGBColorType cRGB;
				//cRGB.r = 153; cRGB.g = 255; cRGB.b = 255;	pPref->clrIdx[0] = WinRGBToIndex(&cRGB);
				//cRGB.r = 255; cRGB.g = 255; cRGB.b = 191; pPref->clrIdx[1] = WinRGBToIndex(&cRGB);
				//cRGB.r = 0xEE; cRGB.g = 0xEE; cRGB.b = 0xEE; pPref->clrIdx[1] = WinRGBToIndex(&cRGB);
				cRGB.r = 0xCC; cRGB.g = 0xFF; cRGB.b = 0xFF; pPref->clrIdx[0] = WinRGBToIndex(&cRGB);
				cRGB.r = 0xFF; cRGB.g = 0xFF; cRGB.b = 0xCC; pPref->clrIdx[1] = WinRGBToIndex(&cRGB);
			}
			break;
	}

	{ //foCXT|[gĂ@\̃`FbN
		UInt32 ftrVal;
		// Nav g邩H
		if(FtrGet(sysFtrCreator, sysFtrNumFiveWayNavVersion, &ftrVal) == errNone && ftrVal != 0) pPref->gAtrb.is.NaviUsable     = true;
		if(FrmGlueNavIsSupported()                                                             ) pPref->gAtrb.is.GlueNaviUsable = true;
		pPref->gAtrb.is.UsableChecked = true;

		// HandSpring foCX(Treo)H
		if(FtrGet(hsFtrCreator, hsFtrIDVersion, &ftrVal) == 0){
			pPref->gAtrb.is.HsDevice = true;
			pPref->gAtrb.is.SwapAlphaNum = true;
		}
	}

	//--- lۑ
	savePref_TableCalc(pPref);
}

//=====================================================================================================================
////--- foCX`FbN  loadPref_TableCalc() ɓ
//void checkUsableFtr(TableCalcPref_t *pTableCalcPref){ 
//	UInt32 ftrVal;
//	TableCalcPref_t cTableCalcPref;
//
//	if(pTableCalcPref == NULL){
//		pTableCalcPref = &cTableCalcPref;
//		loadPref_TableCalc(pTableCalcPref);
//	}
//
//	if(FtrGet(sysFtrCreator, sysFtrNumFiveWayNavVersion, &ftrVal) == errNone && ftrVal != 0) pTableCalcPref->bfHTC |=  HTC_NaviUsable;
//	else                                                                                     pTableCalcPref->bfHTC &= ~HTC_NaviUsable;
//	if(FrmGlueNavIsSupported()                                                             ) pTableCalcPref->bfHTC |=  HTC_GlueNaviUsable;
//	else                                                                                     pTableCalcPref->bfHTC &= ~HTC_GlueNaviUsable;
//	pTableCalcPref->bfHTC |= HTC_UsableChecked;
//
//	savePref_TableCalc(pTableCalcPref);
//}

//--- ftHgϐݒ
void setDefName(Char *nameStr, int pos){ //OUTPUT: obt@͊mȂBŒłRȏ̗̈mۂꂽϐ鎖҂ĂB
#define NAlpha  25
#define SAlpha	(((int)(NAlpha/MaxDispRow))*(int)MaxDispRow)
	//if(          pos < MaxDispRow       ) StrPrintF(nameStr, "Z%c",  (char)('a'+pos)               );   //1st page - for consants
	//else if(     pos < MaxDispRow+SAlpha) StrPrintF(nameStr,  "%c",  (char)('a'+ pos-MaxDispRow)   );   //2md, 3rd page - for main page
	//else{ int tt=pos - MaxDispRow-SAlpha; StrPrintF(nameStr, "%c%c", (char)('A'+tt/NAlpha)
	//																								,                (char)('A'+tt-26*(tt/NAlpha)) ); } //other page
	// 'e'  'E' ͕ϐ珜Oi1.23e+2 ̉߂߂ȂBϐƂ 1.23 * 'e' + 2 OR wLƂ 1.23 * 10^2 j
	if(          pos < MaxDispRow       ){ StrPrintF(nameStr, "Z%c",  (char)('a'+pos)               ); } //1st page - for consants
	else if(     pos < MaxDispRow+SAlpha){ char cChr =                       'a' + pos-MaxDispRow;       //2md, 3rd page - for main page
		if(cChr >= 'e') cChr++;              StrPrintF(nameStr,  "%c",  cChr                          ); }
	else{ int tt=pos - MaxDispRow-SAlpha; StrPrintF(nameStr, "%c%c", (char)('a'+tt/NAlpha)
																									,                (char)('a'+tt-26*(tt/NAlpha)) ); } //other page
}

//=====================================================================================================================
//--- f[^x[X̏擾
//Int16 findNameInHtcDB(Char *sStr){ // SẴR[hĴŒx
//	Int16 foundPos = -1;
//	MyGlobals_t* gP = getMyGlobals();
//	UInt16 cRec, cRow;
//	TableCalc_Record_t bufRec;
//
//	// p[^̃`FbN
//	if(sStr == NULL){ /*G[*/ return -4; }
//	if(gP->nDbRecords < 1){ /*G[*/ return -2; }
//	if(StrLen(sStr) < 1){ /*G[*/ return -3; }
//
//	// R[h擾ƖO`FbN
//	for(cRec=0; cRec < gP->nDbRecords; cRec++){
//		loadOneRecord(cRec, &bufRec);
//		for(cRow=0; cRow<MaxDispRow; cRow++){
//			if(StrCompare(bufRec.row[cRow].name, sStr) == 0){
//				foundPos = cRec * MaxDispRow + cRow; 
//				break;
//			}
//		}
//		if(foundPos >= 0) break;
//	}
//
//	return foundPos;
//}

// OɎgĂ邩ǂCSR[h`FbN
// Oꗗ̓obt@ɂ܂Ă̂ŁCR[h̕ύXx findNameInHtcDB(NULL) Ƃăobt@NAׂ

Int16 findNameInHtcDB(Char *sStr){ // Oe[uɊmۂ
	Int16 foundPos = -1;
	UInt16 cRow;
	//static UInt32 szNameTable = 0;    // MyGlobals_t ɂĕێ
	//static MemHandle mhMhName = NULL; // MyGlobals_t ɂĕێ
	MemHandle        *pMhName = NULL;
	Char               *pName = NULL;
	MyGlobals_t* gP = getMyGlobals();

	// obt@NA
	if(sStr == NULL || StrLen(sStr) < 1){
		if(gP->mhMhName != NULL){
			pMhName = MemHandleLock(gP->mhMhName);
			for(cRow=0; cRow < gP->szNameTable; cRow++){
				if(pMhName[cRow] != NULL){
					MemHandleFree(pMhName[cRow]);
					pMhName[cRow] = NULL;
				}
			}
			MemHandleUnlock(gP->mhMhName);
			MemHandleFree(gP->mhMhName);
			gP->mhMhName = NULL;
			gP->szNameTable = 0;
		}
		return -2;
	}

	// obt@ȂT[`ƓɃmۂobt@ɕێ
	if(gP->mhMhName == NULL){ 
		//TableCalc_Record_t bufRec; //̍\̂邩lXg̐[֐ĂяoƃG[łHH ReadOnly o[W̕g
		TableCalc_Record_t *pRec = (TableCalc_Record_t*)MemPtrNew(sizeof(TableCalc_Record_t));
		UInt16 cRec;
		//MyGlobals_t* gP = getMyGlobals();
	

		if(pRec == NULL){ /*G[*/ return -3; }
		if(gP->nDbRecords < 1){ /*G[*/ return -4; }
		//MemSet(pRec, sizeof(TableCalc_Record_t), 0); //[NA


		gP->szNameTable = gP->nDbRecords * MaxDispRow;
		gP->mhMhName = MemHandleNew(sizeof(MemHandle*) * gP->szNameTable);  if(gP->mhMhName == NULL){ /*G[*/ return -4; }

		pMhName = MemHandleLock(gP->mhMhName);

		for(cRec=0; cRec < gP->nDbRecords; cRec++){
			loadOneRecord(cRec, pRec);
			for(cRow=0; cRow<MaxDispRow; cRow++){
				pMhName[cRec*MaxDispRow+cRow] = MemHandleNew(sizeof(Char) * (StrLen(pRec->row[cRow].name)+2));
				if(pMhName[cRec*MaxDispRow+cRow] == NULL){ /*G[*/ 
					UInt16 itr;
					for(itr=0; itr < cRec*MaxDispRow+cRow; itr++)
						if(pMhName[itr] != NULL) MemHandleFree(pMhName[itr]);
					MemHandleUnlock(gP->mhMhName); MemHandleFree(gP->mhMhName); gP->mhMhName = NULL;
					MemPtrFree(pRec);
					return -5; 
				}

				pName = MemHandleLock(pMhName[cRec*MaxDispRow+cRow]);

				if(!pRec->pAtrb.is.localVar)
					StrCopy(pName,  pRec->row[cRow].name);
				else
					StrPrintF(pName, "!%s", pRec->row[cRow].name);

				if(StrCompare(pName,  sStr) == 0)
					if(StrLen(pName) > 1 || gP->cPref.gAtrb.is.use1CharAsRef)
						foundPos = cRec * MaxDispRow + cRow; 
				
				MemHandleUnlock(pMhName[cRec*MaxDispRow+cRow]);
			}
		}

		MemHandleUnlock(gP->mhMhName);
		MemPtrFree(pRec);
	}
	// obt@Ȃ炻`FbN
	else{
		pMhName = MemHandleLock(gP->mhMhName);

		for(cRow=0; cRow < gP->szNameTable; cRow++){
			pName = MemHandleLock(pMhName[cRow]);
			if(StrCompare(pName,  sStr) == 0)
				if(StrLen(pName) > 1 || gP->cPref.gAtrb.is.use1CharAsRef)
					foundPos = cRow; 
			MemHandleUnlock(pMhName[cRow]);
			if(foundPos >= 0)	break;
		}

		MemHandleUnlock(gP->mhMhName);
	}

	return foundPos;
}

Int16 findNameInHtcDB_ReadOnly(MyGlobals_t* gP, Char *sStr){ //\zς݂̃obt@ǂݍނ
	MemHandle *pMhName = NULL;
	Char        *pName = NULL;
	Int16 foundPos = -1;
	UInt16 cRow;

	if(gP->mhMhName == NULL || gP->szNameTable < 1 || sStr == NULL || StrLen(sStr) < 1) return -1;

	pMhName = MemHandleLock(gP->mhMhName);
	
	for(cRow=0; cRow < gP->szNameTable; cRow++){
		pName = MemHandleLock(pMhName[cRow]);
		if(StrCompare(pName,  sStr) == 0)
			if(StrLen(pName) > 1 || gP->cPref.gAtrb.is.use1CharAsRef)
				foundPos = cRow; 
		MemHandleUnlock(pMhName[cRow]);
		if(foundPos >= 0)	break;
	}
	
	MemHandleUnlock(gP->mhMhName);
	
	return foundPos;
}


Int16 getListOfPageTitle_MemPtrNew(Char ***strPageTitles, Boolean isPrintLocalPage){
	Int16 numPages;
	MyGlobals_t* gP = getMyGlobals();
	UInt16 cRec;
	//TableCalc_Record_t bufRec;
	TableCalc_Record_t *pRec = (TableCalc_Record_t*)MemPtrNew(sizeof(TableCalc_Record_t));
	if(pRec == NULL){ /*G[*/ numPages = -1; return numPages; }
	//MemSet(pRec, sizeof(TableCalc_Record_t), 0); //[NA

	// p[^̃`FbN
	if(gP->nDbRecords < 1){ /*G[*/ MemPtrFree(pRec); numPages = -2; return numPages; }

	numPages = gP->nDbRecords;
	// m
	(*strPageTitles) = (Char**)MemPtrNew(numPages * sizeof(Char*));
	if((*strPageTitles) == NULL){ /*G[*/ MemPtrFree(pRec); numPages = -3; return numPages; }
	for(cRec=0; cRec < numPages; cRec++){
		// R[h擾
		loadOneRecord(cRec, pRec);
		// m
		(*strPageTitles)[cRec] = (Char*)MemPtrNew(sizeof(Char) * (StrLen(pRec->title)+2));
		if((*strPageTitles)[cRec] == NULL){ MemPtrFree(pRec); numPages = cRec; return numPages; }
		// ORs[
		if(!isPrintLocalPage && pRec->pAtrb.is.localVar) StrCopy((*strPageTitles)[cRec], "-");
		else                                             StrCopy((*strPageTitles)[cRec], pRec->title);
	}

	MemPtrFree(pRec);
	return numPages;
}


//=====================================================================================================================
//--- R[h̒ǉƍ폜
DBErr_t addNewRecord(UInt16 newRecPos){
	MyGlobals_t* gP = getMyGlobals();
	DBErr_t cDbErr = DB_ErrNone;

	// p[^̃`FbN
	if(gP->nDbRecords >= MaxPages) return DBA_MaxPagesOver;
	if(newRecPos > gP->nDbRecords) newRecPos = gP->nDbRecords;

	// Ƃ肠݂̃obt@߂Ă
	//if(gP->pPage != NULL && gP->cPref.cDispPage >= 0 && gP->cPref.cDispPage < gP->nDbRecords)
		saveOneRecord(gP->cPref.cDispPage, gP->pPage);

	
	{ // Vy[W̏lݒ
		UInt16 cRow, n1, n10, n100;
		Boolean isNotDup = false;
		Char strNewName[MaxLen_Name];

		if(gP->pPage == NULL)
			gP->pPage = (TableCalc_Record_t*)MemPtrNew(sizeof(TableCalc_Record_t));
		MemSet(gP->pPage, sizeof(TableCalc_Record_t), 0); //[NA

		//StrPrintF(gP->pPage->title, "untitled %02d", newRecPos);
		{ // VKy[W
			UInt16 cPg, uNo = 0;
			Boolean isMatch;
			Char **strPageTitles;
			Int16 numPages = getListOfPageTitle_MemPtrNew(&strPageTitles, true);
			MemHandle mhStr = DmGet1Resource('tSTR', SrID_PgUntitled);
			Char      *pStr = NULL;

			if(mhStr != NULL) pStr = MemHandleLock(mhStr);
			
			for(uNo=0; uNo <= MaxPages; uNo++){
				//StrPrintF(gP->pPage->title, "untitled %02u", uNo);
				if(pStr != NULL && StrLen(pStr) > 0) StrPrintF(gP->pPage->title, "%s %02u", pStr, uNo);
				else                                 StrPrintF(gP->pPage->title, "%02u", uNo);
				isMatch = false;
				for(cPg=0; cPg<numPages; cPg++){
					if( StrCompare(gP->pPage->title, strPageTitles[cPg]) == 0 ){ isMatch = true; break; }
				}
				if(!isMatch) break;
			}
			if(pStr != NULL) MemHandleUnlock(mhStr); mhStr = NULL; pStr = NULL;
			// getListOfPageTitle_MemPtrNew() ŊmۂJ
			for(cPg=0; cPg<numPages; cPg++) 
				MemPtrFree(strPageTitles[cPg]);
			MemPtrFree(strPageTitles);
		}

		//n100=0; n10=0; n1=0;
		n100=0; n10= (newRecPos>0) ? newRecPos-1 : newRecPos; n1=0; //ȉ̃[vԂHĂ̂ŁCŏdoɂ悤ȏlݒ肷
		//{Char dbuf[32];StrPrintF(dbuf," FN --   ");WinDrawChars(dbuf,StrLen(dbuf),90,1);}
		for(cRow=0; cRow<MaxDispRow; cRow++){
			StrPrintF(strNewName, "AAA");
			isNotDup = false;
			for( ; n100<NAlpha+1; n100++){
				for( ; n10<NAlpha; n10++){
					for( ; n1<NAlpha; n1++){
						switch(n100){
							case 0:                            strNewName[0]='a'+n10; strNewName[1]='a'+n1; strNewName[2]='\0';break;
							case 1:                            strNewName[0]='A'+n10; strNewName[1]='a'+n1; strNewName[2]='\0';break;
							case 2:                            strNewName[0]='A'+n10; strNewName[1]='A'+n1; strNewName[2]='\0';break;
							default: strNewName[0]='A'+n100-3; strNewName[1]='A'+n10; strNewName[2]='A'+n1; strNewName[3]='\0';break;
						//case 0:	 StrPrintF(strNewName,   "%c%c",                     (char)('a'+n10), (char)('a'+n1)); break;
						//case 1:	 StrPrintF(strNewName,   "%c%c",                     (char)('A'+n10), (char)('a'+n1)); break;
						//case 2:	 StrPrintF(strNewName,   "%c%c",                     (char)('A'+n10), (char)('A'+n1)); break;
						//default: StrPrintF(strNewName, "%c%c%c", (char)('A'+n100-1), (char)('A'+n10), (char)('A'+n1)); break;
						}
						//isNotDup = (findMachNamePos(strNewName) < 0);
						isNotDup = (findNameInHtcDB(strNewName) < 0);
						//if(isNotDup){Char dbuf[32];StrPrintF(dbuf," FN%2d   ",cRow);WinDrawChars(dbuf,StrLen(dbuf),90,1);}
						if(isNotDup){ n1++; break; }
					}
					if(isNotDup) break;
					n1=0;
				}
				if(isNotDup) break;
				n10=0;
			}
			StrPrintF(gP->pPage->row[cRow].name, strNewName);
			StrPrintF(gP->pPage->row[cRow].expr, "0"); 
			{ int dRow; for(dRow=0; dRow<MaxDependsOn; dRow++) gP->pPage->row[cRow].dependsOn[dRow] = false; }
			gP->pPage->row[cRow].ansVal = 0.0;
			gP->pPage->row[cRow].ansErr = EE_NONE;
			gP->pPage->row[cRow].ansFmt = AF_D;
			gP->pPage->row[cRow].ansDig = 0;
			gP->pPage->row[cRow].rowHgt = 1;
			gP->pPage->row[cRow].clrIdx = 0;
			gP->pPage->row[cRow].top    = PosRowY0 + (PosRowDY+1) * cRow;
			gP->pPage->row[cRow].rAtrb.all = 0x0;
			gP->pPage->row[cRow].rAtrb.is.notEditable = false;
			gP->pPage->row[cRow].rAtrb.is.notVisible  = false;
			gP->pPage->col = gP->cPref.col;
			gP->pPage->dispMode = TDM_1x10;
			gP->pPage->pAtrb.all = 0x0;
			gP->pPage->pAtrb.is.UnitDegree = gP->cPref.gAtrb.is.UnitDegree;
		}
	}

	{ // Vy[Wȍ~̏ꏊ炷
		UInt16 cRec;
		//TableCalc_Record_t bufRec; //ϐłł\̂mۂƎsG[o邱ƂH
		TableCalc_Record_t *pRec = (TableCalc_Record_t*)MemPtrNew(sizeof(TableCalc_Record_t));
		//{Char dbuf[32];StrPrintF(dbuf," %d->%d ",(int)(gP->nDbRecords-1),(int)newRecPos);WinDrawChars(dbuf,StrLen(dbuf),90,1);}
		if(pRec != NULL){
			//MemSet(pRec, sizeof(TableCalc_Record_t), 0); //[NA
			for(cRec = gP->nDbRecords-1; cRec >= newRecPos; cRec--){
				loadOneRecord(cRec  , pRec);
				saveOneRecord(cRec+1, pRec);
			}
			MemPtrFree(pRec);
		}
	}

	// Vy[Wۑ
	gP->cPref.cDispPage = newRecPos;
	cDbErr = saveOneRecord(gP->cPref.cDispPage, gP->pPage);

	{
		DmOpenRef pDB = DmOpenDatabaseByTypeCreator(TableCalc_MainDBType, TableCalc_CrtrID1q, dmModeReadOnly);
		if(pDB != NULL){
			gP->nDbRecords = DmNumRecords(pDB);
			DmCloseDatabase(pDB);
		}
		else if(cDbErr == DB_ErrNone) gP->nDbRecords++;
	}

	findNameInHtcDB(NULL);
	return cDbErr;
}


DBErr_t delOneRecord(UInt16 delRecPos){
	MyGlobals_t* gP = getMyGlobals();

	// p[^̃`FbN
	if(gP->nDbRecords <= 1){ /*G[*/ return DBD_MinPageNum; }
	if(delRecPos >= gP->nDbRecords){ /*G[*/ return DBD_NoPage; }

	//// Ƃ肠݂̃obt@߂Ă
	//if(gP->pPage != NULL && gP->cPref.cDispPage >= 0 && gP->cPref.cDispPage < gP->nDbRecords)
	//	saveOneRecord(gP->cPref.cDispPage, gP->pPage);
	
	//{ // y[Wȍ~炷
	//	UInt16 cRec;
	//	TableCalc_Record_t bufRec;
	//	for(cRec = delRecPos; cRec < gP->nDbRecords-1; cRec++){
	//		loadOneRecord(cRec+1, &bufRec);
	//		saveOneRecord(cRec  , &bufRec);
	//	}
	//}
	//
	//{ // ]vȃR[h폜
	//	DmOpenRef pDB = DmOpenDatabaseByTypeCreator(TableCalc_MainDBType, TableCalc_CrtrID1q, dmModeReadWrite);
	//	if(pDB != NULL){
	//		DmRemoveRecord(pDB, gP->nDbRecords-1);
	//		gP->nDbRecords = DmNumRecords(pDB);
	//		DmCloseDatabase(pDB);
	//	}
	//	else
	//		return DBD_DelRecErr;
	//}

	if(delRecPos < gP->nDbRecords){ // R[h폜
		DmOpenRef pDB = DmOpenDatabaseByTypeCreator(TableCalc_MainDBType, TableCalc_CrtrID1q, dmModeReadWrite);
		if(pDB == NULL) return DBD_DelRecErr;

		DmRemoveRecord(pDB, delRecPos);
		gP->nDbRecords = DmNumRecords(pDB);
		DmCloseDatabase(pDB);
	}

	findNameInHtcDB(NULL);
	return DB_ErrNone;
}


//=====================================================================================================================
//--- obt@f[^ <-> f[^x[X Z[u^[h
DBErr_t saveOneRecord(UInt16 cSavePage, TableCalc_Record_t* pPage){
	Err dbErr;
	DmOpenRef pDB = NULL;

	if(pPage == NULL){ /*G[*/ return DBS_NullPtr; }

	// DB J
	pDB = DmOpenDatabaseByTypeCreator(TableCalc_MainDBType, TableCalc_CrtrID1q, dmModeReadWrite);

	// f[^x[XꍇV݂
	if(pDB == NULL){
		LocalID dbID;
		UInt16 cardNo, dbAttrb;
		dbErr = DmCreateDatabase(0, TableCalc_MainDBName, TableCalc_CrtrID1q, TableCalc_MainDBType, false);    // DB VK쐬
		if(dbErr != errNone){ /*G[*/ return DBS_CreateErr; }
		pDB = DmOpenDatabaseByTypeCreator(TableCalc_MainDBType, TableCalc_CrtrID1q, dmModeReadWrite);          // 쐬 DB J
		DmOpenDatabaseInfo(pDB, &dbID, NULL, NULL, &cardNo, NULL);                                             
		DmDatabaseInfo(   cardNo, dbID, NULL, &dbAttrb, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL); // DB ̑擾
		dbAttrb |= dmHdrAttrBackup;                                                                            // obNAbvt
		DmSetDatabaseInfo(cardNo, dbID, NULL, &dbAttrb, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL); // DB ̑
	}

	if(pDB == NULL){ /*G[*/ return DBS_OpenErr;	}

	// f[^ DB ɕۑ
	{
		MemHandle mhRec = NULL;
		//MemPtr     pRec = NULL;
		// DB ̃JgR[h̃nh擾^V
		if(cSavePage < DmNumRecords(pDB)) mhRec = DmGetRecord(pDB, (UInt16 ) cSavePage);                             // R[h̃nh擾
		if(mhRec == NULL                ) mhRec = DmNewRecord(pDB, (UInt16*)&cSavePage, sizeof(TableCalc_Record_t)); // ꍇ̓R[hV
		if(mhRec == NULL                ){
			cSavePage = DmNumRecords(pDB);  mhRec = DmNewRecord(pDB, (UInt16*)&cSavePage, sizeof(TableCalc_Record_t));
		}
		// data copy : obt@f[^ -> JgR[h
		if(mhRec != NULL){
			dbErr = DmWrite(MemHandleLock(mhRec), 0, pPage, sizeof(TableCalc_Record_t));
			DmReleaseRecord(pDB, cSavePage, true);
			MemHandleUnlock(mhRec);
			if(dbErr != errNone){ DmCloseDatabase(pDB); /*G[*/ return DBS_WriteErr; }
		}
		else{ DmCloseDatabase(pDB); /*G[*/ return DBS_GetRecErr;  }
		// DB close
		DmCloseDatabase(pDB);
		findNameInHtcDB(NULL);
		return DB_ErrNone;
	}
	
	findNameInHtcDB(NULL);
	return DBS_ExErr;
}


//--- f[^x[Xǂݍ
DBErr_t loadOneRecord(UInt16 cLoadPage, TableCalc_Record_t* pPage){
	Err dbErr;
	DmOpenRef pDB = NULL;

	//if(pPage != NULL) return DBL_NotFreePtr; //݂̃y[WĂȂȂǂݍ܂ȂŏI
	if(pPage == NULL){ /*G[*/ return DBL_NullPtr; }

	// DB Open
	pDB = DmOpenDatabaseByTypeCreator(TableCalc_MainDBType, TableCalc_CrtrID1q, dmModeReadOnly);

	if(pDB != NULL){           // DB ꍇ -> eǂݍ
		// R[h`FbN
		if(cLoadPage >= DmNumRecords(pDB)){
			DmCloseDatabase(pDB); 
			return DBL_ExeedRecNo;
		}
		
		// f[^x[Xei[p̃m
		//pPage = (TableCalc_Record_t*)MemPtrNew(sizeof(TableCalc_Record_t)); // X̃y[Wf[^i[p̃擾
		if(pPage == NULL){
			/*G[*/
			DmCloseDatabase(pDB); 
			return DBL_MemPtrNewErr;
		}
		else{
			// DB ̃JgR[h̃nh擾
			MemHandle mhRec = DmGetRecord(pDB, cLoadPage);
			// data copy : JgR[h -> ǂݍ݃f[^
			if(mhRec != NULL){
				dbErr = MemMove(pPage, MemHandleLock(mhRec), sizeof(TableCalc_Record_t)); // Copy Record -> Buf
				DmReleaseRecord(pDB, cLoadPage, false);
				MemHandleUnlock(mhRec);
				if(dbErr != errNone){ /*G[*/ return DBL_MemMoveErr; }
			}
			else{ /*G[*/ // R[hǂݍݎsftHgf[^obt@ɃZbg
				int cRow, dRow;
				pPage->pAtrb.all = 0x0;
				pPage->pAtrb.is.UnitDegree = true;
				StrPrintF(pPage->title, "Page%02d\0", cLoadPage);
				for(cRow=0; cRow<MaxDispRow; cRow++){
					setDefName(pPage->row[cRow].name, cLoadPage*MaxDispRow+cRow);
					StrPrintF(pPage->row[cRow].expr, "0\0");
					for(dRow=0; dRow<MaxDependsOn; dRow++) 
						pPage->row[cRow].dependsOn[dRow] = false; 
					pPage->row[cRow].ansVal = 0.0;
					pPage->row[cRow].ansErr = EE_NONE;
					pPage->row[cRow].ansFmt = AF_D;
					pPage->row[cRow].ansDig = 0;
					pPage->row[cRow].rowHgt = 1;
					pPage->row[cRow].clrIdx = 0;
					pPage->row[cRow].top    = PosRowY0 + (PosRowDY+1) * cRow;
					pPage->row[cRow].rAtrb.all = 0x0;
					pPage->row[cRow].rAtrb.is.notEditable = false;
					pPage->row[cRow].rAtrb.is.notVisible  = false;
				}
				pPage->ansFmt   = AF_D;
				pPage->ansDig   = 0;
				pPage->col.nameLeft  = Default_nameLeft;
				pPage->col.nameWidth = Default_nameWidth;
				pPage->col.ansLeft   = pPage->col.nameLeft + pPage->col.nameWidth + 1;
				pPage->col.ansWidth  = Default_ansWidth;
				pPage->col.exprLeft  = pPage->col.ansLeft  + pPage->col.ansWidth  + SpcBtAnsFld;
				//pPage->col.exprWidth = MaxScrX - pPage->col.exprLeft - FldSclWid +2; //+2 ͏XN[o[ɃI[o[bv邽
				pPage->col.exprWidth = MaxScrX - pPage->col.exprLeft - ExprRghtMrgn;
				pPage->dispMode = TDM_1x10;
				DmCloseDatabase(pDB); 
				return DBL_NoDB;
			}
		}
		DmCloseDatabase(pDB); 
	}
	else{ // DB ꍇ -> 
		/*G[*/
		return DBL_NoDB;
	}

	return DB_ErrNone;
}

DBErr_t initCheckDB(UInt16 *pNDbRecords) MSEG2;
DBErr_t initCheckDB(UInt16 *pNDbRecords){
	DmOpenRef pDB = NULL;
	
	(*pNDbRecords) = 0;

	// DB Open
	pDB = DmOpenDatabaseByTypeCreator(TableCalc_MainDBType, TableCalc_CrtrID1q, dmModeReadOnly);

	// DB ꍇ -> eǂݍ
	if(pDB != NULL){
		// R[h擾
		(*pNDbRecords) = DmNumRecords(pDB); 

		DmCloseDatabase(pDB);
		return DB_ErrNone;
	}
	// DB ꍇ -> ftHgݒ DB 쐬ۑ
	else{
		// ftHgf[^쐬
		UInt16 cRecPage, cRow;
		//TableCalc_Record_t tRec;
		TableCalc_Record_t *pRec = (TableCalc_Record_t*)MemPtrNew(sizeof(TableCalc_Record_t));
		
		if(pRec == NULL) return DBL_MemPtrNewErr;

		(*pNDbRecords) = NDefPages;
		for(cRecPage=0; cRecPage<(*pNDbRecords); cRecPage++){
			MemSet(pRec, sizeof(TableCalc_Record_t), 0); //[NA
			// ftHgf[^̐ݒ
			pRec->pAtrb.all = 0x0;
			pRec->pAtrb.is.UnitDegree = true;
			StrPrintF(pRec->title, "Page%02d", cRecPage);
			for(cRow=0; cRow<MaxDispRow; cRow++){
				int dRow; 
				for(dRow=0; dRow<MaxDependsOn; dRow++)
					pRec->row[cRow].dependsOn[dRow] = false;
				setDefName(pRec->row[cRow].name, cRecPage*MaxDispRow+cRow); 
				StrPrintF(pRec->row[cRow].expr, "0"); 
				pRec->row[cRow].ansVal = 0.0;
				pRec->row[cRow].ansErr = EE_NotEval;
				pRec->row[cRow].ansFmt = AF_D;
				pRec->row[cRow].ansDig = 0;
				pRec->row[cRow].rowHgt = 1;
				pRec->row[cRow].clrIdx = 0;
				pRec->row[cRow].top    = PosRowY0 + (PosRowDY+1) * cRow; //if(cRow>4) pRec->row[cRow].top += PosRowDY; //test
				pRec->row[cRow].rAtrb.all = 0x0;
				pRec->row[cRow].rAtrb.is.notEditable = false;
				pRec->row[cRow].rAtrb.is.notVisible  = false;
			}
			pRec->ansFmt   = AF_D;
			pRec->ansDig   = 0;
			pRec->col.nameLeft  = Default_nameLeft;
			pRec->col.nameWidth = Default_nameWidth;
			pRec->col.ansLeft   = pRec->col.nameLeft + pRec->col.nameWidth + 1;
			pRec->col.ansWidth  = Default_ansWidth;
			pRec->col.exprLeft  = pRec->col.ansLeft  + pRec->col.ansWidth  + SpcBtAnsFld;
			//pRec->col.exprWidth = MaxScrX - pRec->col.exprLeft - FldSclWid +2; //+2 ͏XN[o[ɃI[o[bv邽
			pRec->col.exprWidth = MaxScrX - pRec->col.exprLeft - ExprRghtMrgn;
			pRec->dispMode = TDM_1x10;
			// ŏ̃y[Wɂ͒lZbgĂf[^̐ݒ
			if(cRecPage == 0){
				StrPrintF(pRec->title, "Constants");
				cRow=0;	
#define SETROW( __CROW , __NAME , __VAL , __EXPR ) { \
  StrPrintF(pRec->row[ __CROW ].name   , __NAME ); \
	          pRec->row[ __CROW ].ansVal = __VAL   ; \
	StrPrintF(pRec->row[ __CROW ].expr   , __EXPR ); \
}
				if(cRow<MaxDispRow){ SETROW(cRow, "pi"    , 3.14159265, "3.14159265"); cRow++; }
				if(cRow<MaxDispRow){ SETROW(cRow, "inch"  , 2.54      , "2.54"      ); cRow++; }//1 inch= 2.54 cm
				if(cRow<MaxDispRow){ SETROW(cRow, "ft"    , 30.48     , "30.48"     ); cRow++; }//1 ft= 30.48 cm
				if(cRow<MaxDispRow){ SETROW(cRow, "yard"  , 0.9144    , "0.9144"    ); cRow++; }//1 yard = 0.9144 m
				if(cRow<MaxDispRow){ SETROW(cRow, "oz"    , 28.3495231, "28.3495231"); cRow++; }//1 oz= 28.3495231 g
				if(cRow<MaxDispRow){ SETROW(cRow, "lb"    , 453.59237 , "453.59237" ); cRow++; }//1 lb= 453.59237 g
				if(cRow<MaxDispRow){ SETROW(cRow, "gallon", 3.7854118 , "3.7854118" ); cRow++; }//1 gallon = 3.7854118 l
				if(cRow<MaxDispRow){ SETROW(cRow, "x"     , 0         , "0"         ); cRow++; }//
				if(cRow<MaxDispRow){ SETROW(cRow, "y"     , 0         , "0"         ); cRow++; }//
				if(cRow<MaxDispRow){ SETROW(cRow, "z"     , 0         , "0"         ); cRow++; }//
		}

			// ftHgf[^ DB ɕۑ
			{
				DBErr_t cDbErr = saveOneRecord(cRecPage, pRec);
				if(cDbErr != 0){ MemPtrFree(pRec); (*pNDbRecords) = cRecPage; return cDbErr; }
			}
		}
		MemPtrFree(pRec);
	}

	return DB_ErrNone;
}


//=====================================================================================================================
//--- f[^x[X <-> MemoDB Z[u^[h
#define MemoDbType 'DATA'
#define MemoMaxLength 4096

Boolean exportOneRecordHtcDBtoMemoDB(UInt16 htcRecNo){
	Err dbErr;
	TableCalc_Record_t bufHtcRec;
	Char *strToExport = NULL;
	
	dbErr = loadOneRecord(htcRecNo, &bufHtcRec);
	if(dbErr != DB_ErrNone){ /*G[*/ return false; } 
		
	
	{ // strToExport ̃mۂƓe
		MyGlobals_t *gP = getMyGlobals();
		UInt16 cRow;
		Char   ansStr[MaxDispRow][MaxLen__Ans];
		UInt32 strLenToExport = 0;

		// ރf[^̏
		for(cRow=0; cRow<MaxDispRow; cRow++){
			AnswerFormat_t cAnsFmt = bufHtcRec.row[cRow].ansFmt;
			int            cAnsDig = bufHtcRec.row[cRow].ansDig;
			if(cAnsFmt == AF_D) cAnsFmt = bufHtcRec.ansFmt;
			if(cAnsFmt == AF_D) cAnsFmt = gP->cPref.ansFmt;
			if(cAnsDig < 1    ) cAnsDig = bufHtcRec.ansDig;
			if(cAnsDig < 1    ) cAnsDig = gP->cPref.ansDig;
			
			formatResult(bufHtcRec.row[cRow].ansVal, bufHtcRec.row[cRow].ansErr, 
									 //cAnsFmt, cAnsDig, gP->cPref.gAtrb.is.ShowFmtPrfx, gP->cPref.cWid__Ans,
									 cAnsFmt, cAnsDig, gP->cPref.gAtrb.is.ShowFmtPrfx, gP->cPref.col.ansWidth -Sub4FormatAnsWidth,
									 ansStr[cRow]);

		}
		// ݕJEg
		strLenToExport = StrLen(bufHtcRec.title);
		for(cRow=0; cRow<MaxDispRow; cRow++){
			strLenToExport++; //"\n"
			strLenToExport += StrLen(bufHtcRec.row[cRow].name); strLenToExport += StrLen(gP->cPref.strDelim);
			strLenToExport += StrLen(       ansStr[cRow]     ); strLenToExport += StrLen(gP->cPref.strDelim);
			strLenToExport += StrLen(bufHtcRec.row[cRow].expr); 
		}
		strLenToExport++;//"\0"

		// ݃obt@ɃRs[
		strToExport = (Char*)MemPtrNew(sizeof(Char) * (strLenToExport+1));
		MemSet(strToExport, sizeof(Char) * (strLenToExport+1), 0); //[NA
		if(strToExport == NULL){ /*G[*/ return false; }
		//StrPrintF(strToExport, "%s", bufHtcRec.title);
		StrCopy(strToExport, bufHtcRec.title);
		for(cRow=0; cRow<MaxDispRow; cRow++){
			StrNCat(strToExport, "\n", strLenToExport);
			StrNCat(strToExport, bufHtcRec.row[cRow].name, strLenToExport); StrNCat(strToExport, gP->cPref.strDelim, strLenToExport);
			StrNCat(strToExport,        ansStr[cRow],      strLenToExport); StrNCat(strToExport, gP->cPref.strDelim, strLenToExport);
			StrNCat(strToExport, bufHtcRec.row[cRow].expr, strLenToExport); 
		}
		StrNCat(strToExport, "\0", strLenToExport); //KvȂƂ͎vǔÔ
		//strToExport[strLenToExport] = '\0';
	}// strToExport ̃mۂƓe

	//ClipboardAddItem(clipboardText, strToExport, StrLen(strToExport));
	//{Char dbuf[32];StrPrintF(dbuf," <%d> ", (int)StrLen(strToExport));WinDrawChars(dbuf,StrLen(dbuf),70,1);}

	// MemoDB ւ̏
	if(strToExport != NULL && StrLen(strToExport) > 0){
		DmOpenRef  pMemoDB  = NULL;
		MemHandle mhMemoRec = NULL;
		UInt16  memoDbRecNo;
		UInt16  categoryNo;
		UInt16 attrbMemoRec;
		UInt32 strLenToSave = StrLen(strToExport) +1; // +1 ͍Ō'\0'R[hɏނ
		if(strLenToSave > MemoMaxLength) strLenToSave = MemoMaxLength;

		// DB open
		pMemoDB = DmOpenDatabaseByTypeCreator(MemoDbType, sysFileCMemo, dmModeReadWrite);
		if(pMemoDB == NULL){ /*G[*/ MemPtrFree(strToExport); return false; }

		// VKR[h쐬
		memoDbRecNo = DmNumRecords(pMemoDB);
		mhMemoRec = DmNewRecord(pMemoDB, &memoDbRecNo, strLenToSave);
		if(mhMemoRec == NULL){ /*G[*/ DmCloseDatabase(pMemoDB); MemPtrFree(strToExport); return false; }
	
		// R[h֏
		DmWrite(MemHandleLock(mhMemoRec), 0, strToExport, strLenToSave);
		MemHandleUnlock(mhMemoRec);

		// JeS̃`FbN
		categoryNo = CategoryFind(pMemoDB, TableCalc_StrTitle); // ̃JeSɖړĨJeS邩`FbN
		// ړĨJeSV//http://www.mail-archive.com/palm-dev-forum@news.palmos.com/msg03410.html
		if(categoryNo == dmAllCategories){ 
			Char seekCat[dmCategoryLength];
			// gp̃JeSԍT
			for(categoryNo = 0; categoryNo < dmRecNumCategories; categoryNo++){
				CategoryGetName(pMemoDB, categoryNo, seekCat);
				if(seekCat[0] == '\0')
					break;
			}
			// gpJeSȂV݂͂Ȃ
			if(categoryNo == dmRecNumCategories)
				categoryNo = dmAllCategories;
			// 󂫂ΐVJeSݒ肵ẴJeSԍ擾
			else if(categoryNo < dmRecNumCategories){
				CategorySetName(pMemoDB, categoryNo, TableCalc_StrTitle);
				categoryNo = CategoryFind(pMemoDB, TableCalc_StrTitle);
			}
		}

		// ۑR[hɃJeSݒ
		DmRecordInfo(pMemoDB, memoDbRecNo, &attrbMemoRec, NULL, NULL);
		if(categoryNo != dmAllCategories) attrbMemoRec |= categoryNo;
		else                              attrbMemoRec &= ~dmRecAttrCategoryMask;
		DmSetRecordInfo(pMemoDB, memoDbRecNo, &attrbMemoRec, NULL);

		// Close Record, DB
		DmReleaseRecord(pMemoDB, memoDbRecNo, true);
		DmCloseDatabase(pMemoDB);
		
	}//if(strToExport != NULL && StrLen(strToExport) > 0)

	if(strToExport != NULL) MemPtrFree(strToExport);

	return true;
}
//void inportOneRecordMemoDBtoHtcDB() MSEG2;
//void exportHtcDBtoMemoDB() MSEG2;
//void inportMemoDBtoHtcDB() MSEG2;


//=====================================================================================================================
//--- O[oϐ֗p̎擾
MyGlobals_t* getMyGlobals(void){
	MyGlobals_t* gP = NULL;

	//--- ݒς݂̃AhXǂݏo
	FtrGet(TableCalc_CrtrID1q, TableCalc_FtrID_MyGlobals, (UInt32*)&gP);//tB[`ɕۑAhX̎擾݂
	if(gP != NULL) return gP;                                           //ݒς݂Ȃ璼ɏI

	//--- tB[`ݒȂ烁m
	gP = (MyGlobals_t*)MemPtrNew(sizeof(MyGlobals_t));                  //̈m
	if(gP == NULL) return NULL;
	//MemPtrSetOwner(gP, 0);                                            //L҂OSɂăVXeŜQƉ\
	MemSet(gP, sizeof(MyGlobals_t), 0);                                 //[NA
	FtrSet(TableCalc_CrtrID1q, TableCalc_FtrID_MyGlobals, (UInt32)gP);  //tB[`Ƀ̏ꏊۑ

	//--- i[񏉊

	//- vt@X̓ǂݍ
	loadPref_TableCalc(&(gP->cPref));
	{ //foCXT|[gĂ@\̃`FbN
		UInt32 ftrVal;
		// Nav g邩H
		if(FtrGet(sysFtrCreator, sysFtrNumFiveWayNavVersion, &ftrVal) == errNone && ftrVal != 0) gP->cPref.gAtrb.is.NaviUsable     = true;
		if(FrmGlueNavIsSupported()                                                             ) gP->cPref.gAtrb.is.GlueNaviUsable = true;
		gP->cPref.gAtrb.is.UsableChecked = true;
		// HandSpring foCX(Treo)H
		if(FtrGet(hsFtrCreator, hsFtrIDVersion, &ftrVal) == 0) gP->cPref.gAtrb.is.HsDevice = true;
	}

	//- f[^x[X̓ǂݍ
	gP->nDbRecords = 0;
	initCheckDB(&(gP->nDbRecords));
	//gP->pMhPage = NULL;
	//gP->pPage = NULL;
	//loadTableCalcMainDB(&(gP->nDbRecords), &(gP->pMhPage)); // R[h擾Cf[^x[Xei[p̃mہCcaẽRs[
	if(gP->cPref.cDispPage >= gP->nDbRecords) gP->cPref.cDispPage = gP->nDbRecords-1;
	gP->pPage = (TableCalc_Record_t*)MemPtrNew(sizeof(TableCalc_Record_t));
	loadOneRecord(gP->cPref.cDispPage, gP->pPage);

	//- ̑lݒ
	gP->szNameTable = 0;
	gP->mhMhName = NULL;
	gP->bufUndoExpr[0] = '\0';
	gP->keyRepMode = KR_NONE;
	gP->cFocusFldRow = -1;
	{
		UInt16 cRow;//, dRow;
		for(cRow=0; cRow<MaxDispRow; cRow++){
			gP->isAnsDispUpToDate[cRow] = false;
			//gP->cAnsVal[cRow] = 0.0;
			//gP->cAnsErr[cRow] = EE_NONE;
			//gP->cDepend[cRow].all = 0x0;
			////for(dRow=0; dRow<MaxDispRow; dRow++)
			////	gP->cDepend[dRow][cRow] = false;
		}
		//gP->cFocusFldRow = -1;
	}

	return gP;
}

//--- O[oϐ֗p̊J
void clearMyGlobals(MyGlobals_t* gP) MSEG2;
void clearMyGlobals(MyGlobals_t* gP){
	if(gP != NULL){

		// Œnh̊J
		//if(gP->pPage != NULL){
		//	if(gP->cPref.cDispPage < gP->nDbRecords) MemHandleUnlock(gP->pMhPage[gP->cPref.cDispPage]);
		//	gP->pPage = NULL;
		//}

		// vt@X̏߂
		savePref_TableCalc(&(gP->cPref));

		// f[^x[X֏߂
		//saveTableCalcMainDB(gP->nDbRecords, gP->pMhPage); 
		if(gP->pPage != NULL){
			if(gP->cPref.cDispPage >= 0 && gP->cPref.cDispPage < gP->nDbRecords)
				saveOneRecord(gP->cPref.cDispPage, gP->pPage);
			MemPtrFree(gP->pPage);
		}

		//// loadTableCalcMainDB() Ŋmۂ̊J
		//{
		//	int cPage;
		//	for(cPage=0; cPage<gP->nDbRecords; cPage++)
		//		MemHandleFree(gP->pMhPage[cPage]);
		//}
		//MemPtrFree(gP->pMhPage);

		MemPtrFree(gP);
	}
	FtrUnregister(TableCalc_CrtrID1q, TableCalc_FtrID_MyGlobals);
}

//=====================================================================================================================
UInt32 PilotMain(UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags){
	
	switch(cmd){
		case sysAppLaunchCmdNormalLaunch:       // ʏN 
			{
				Err cErr = errNone;
				MyGlobals_t* gP = NULL;

				cErr = MyMathLibOpen();
				if(cErr != 0){ /*G[*/ return errNone; }

				gP = getMyGlobals();
				if(gP == NULL){ /*G[*/ return errNone; }

				TsmSetFepMode(NULL, tsmFepModeOff);
				execForm(cmd);    

				findNameInHtcDB(NULL); // ֐ŕێĂ郁̊J
				clearMyGlobals(gP);

				MyMathLibClose();
				if(cErr != 0){ /*G[*/ ; }
			}
			break;
			
		default: 
			return errNone;
	}
	
	return errNone;
}
