// HalTableCalc.h  -*- c++ -*-  Time-stamp: <2008/03/18>
// for HalTableCalc
// (C) 2005-2008 HAL <http://hal9.blog3.fc2.com> HAL.Kinosita@gmail.com

// GPL ɊÂC̃\[XR[h̎gpCρCĔzz͎RłB

#ifndef __HalTableCalc_H__
#define __HalTableCalc_H__

#define DBG1

#define TableCalc_PrefVer05b 1
#define TableCalc_PrefVer08b 1
#define TableCalc_PrefVer    1

#define TableCalc_StrTitle   "TableCalc"
#define TableCalc_CrtrID1q   'hCal'
#define TableCalc_CrtrID2q   "hCal"
#define TableCalc_Type1q     'appl'
#define TableCalc_VerStr     "0.8b"
#define TableCalc_MainDBType 'DATA'
#define TableCalc_MainDBName "HalTableCalcDB"

#define TableCalc_IsSavedPref     1
#define TableCalc_PrefID_Base     1

#define TableCalc_FtrID_MyGlobals 1
#define TableCalc_FtrID_lastPush  100

#define NDefPages    3
#define MaxPages     50 //20  // max pages 
#define NPageNULL    (MaxPages+10)
#define MaxDispRow   10  // max row number in one page

#define MaxLen_Name  16  // max char length for StID_C__Index_R00 & OneRowRecord_t.name
#define MaxLen__Ans  32  // max char length for StID_C_Answer_R00
#define MaxLen_Expr 128  // max char length for FdID_C__Input_R00 & OneRowRecord_t.input
#define MaxLenTitle  32  // max char length for page title
#define MaxAnsDig    12  // ̍ő包 ̍ől

#define WidTabCur   110

#define TabCurHgt_NoHead 13
#define PosRowY0_NoHead 30
#define PosRowDY_NoHead 12
#define TabCurHgt 12
#define PosRowY0 40 // 擪 row  top  y W
#define PosRowDY 11 //     e row  
#define LblTopDY 10


#define Sub4FormatAnsWidth 3 // formatResult() ɓn AnsWidth ig̕HjZ߂ɂĂ
#define SpcBtAnsFld 3 // Ans  Expr ̌
//#define FldSclWid 3 //7 // XN[o[̕
#define ExprRghtMrgn 2 //ʉE[ƐtB[ȟ

#define MaxScrX 160
#define MaxScrY 160

#define Default_nameLeft  -2 //0  
#define Default_nameWidth 32 //26
#define Default_ansWidth  53 //55
#define Min_nameWidth 10
#define Min_ansWidth  20
#define Min_exprWidth 25
#define Max_nameWidth (MaxScrX              -Min_ansWidth-SpcBtAnsFld-Min_exprWidth)
#define Max_ansWidth  (MaxScrX-Min_nameWidth             -SpcBtAnsFld-Min_exprWidth)
#define Max_exprWidth (MaxScrX-Min_nameWidth-Min_ansWidth-SpcBtAnsFld)

#define Min_Sd_ansLeft  (Min_nameWidth+Default_nameLeft+1)
#define Max_Sd_ansLeft  (Max_nameWidth+Default_nameLeft+1)
//#define Min_Sd_exprLeft (MaxScrX-Max_exprWidth-FldSclWid+2)
//#define Max_Sd_exprLeft (MaxScrX-Min_exprWidth-FldSclWid+2)
#define Min_Sd_exprLeft (MaxScrX-Max_exprWidth-ExprRghtMrgn)
#define Max_Sd_exprLeft (MaxScrX-Min_exprWidth-ExprRghtMrgn)

#define MyFrmUpdateCode_MyRedraw              87 //l͓K
#define MyFrmUpdateCode_Restore_AppMain       88
#define MyFrmUpdateCode_RetFrom_FmID_EditExpr 89

#ifndef __RSC__

#define MSEG2 __attribute__ ((section("mseg2")))
#define MSEG3 __attribute__ ((section("mseg3")))

//===== App Pref Info ======================================================
typedef enum { AF_D=0, AF_g=1, AF_f=2, AF_e=3, AF_h=4, AF_b=5, AF_Round=6, AF_Floor=7, AF_Ceil=8 } AnswerFormat_t;//4bit,MAX=15
typedef struct { Int16 nameLeft, nameWidth, ansLeft, ansWidth, exprLeft, exprWidth; } ColumnPos_t;

typedef union {
	struct { 
		Boolean RememberLastPos:1;
		Boolean UsableChecked  :1;
		Boolean NaviUsable     :1;
		Boolean GlueNaviUsable :1;
		Boolean HsDevice       :1; // if they're on a handspring device

		Boolean SwapAlphaNum   :1; // swap "e" <-> "1" when double click
		Boolean UnitDegree     :1; // degree or radian for sin(), cons() ...
		Boolean ShowFmtPrfx    :1; // add "r)" for format round()
		Boolean UseVarOnOtherPg:1; 
		Boolean AllowRecursive :1; // zQƂłG[\Ȃ

		Boolean notDrawMrkMltLn:1; // sɘj鐔ɏȃ}[N\B}
		Boolean notAutoSelect  :1; // tB[h̃tH[JX؂ւ玩IɑSI }
		Boolean autoSelectAll  :1; // IɑSI͎sȓ̂ƂB̈s𖳂B
		Boolean use1CharAsRef  :1; // ftHgłPϐ͑y[WQƂȂB̃[KpȂB
		Boolean localVar       :1; //Yy[W̕ϐ͑Sđ̃y[WQƂȂBႤy[WȂ瓯ϐg

		Boolean dblTap4fldMenu :1; //tB[h̃_u^bvŕҏWEChEĴłȂj[\
		Boolean hideColumnTitle:1; //e̖O[Name][Answer][Expression]\
		Boolean immediateEval  :1; //ꕶƂɓXV

		UInt32 reserved:14;
	}       is;
	UInt32 all;
} GlobalPrefAttrb_t;

typedef enum {IEM_FixAll_Scroll=0, IEM_FixPosWid_ExpHgt=1, IEM_FixHgt_MvPosExpWid=2, IEM_ChngAll=3, } InputExpandMode_t;

typedef struct {
	GlobalPrefAttrb_t gAtrb      ;
	UInt16            cDispPage  ; // ݂̕\y[WԍB
	UInt16            cDispRows  ; // ݂̕\s <= Py[W̍ős(MaxDispRow 10)
	UInt16            dblClkMs   ; // dur for double click judgement < 65536 ms
	AnswerFormat_t    ansFmt     ;
	UInt8             ansDig     ;
	Char              strDelim[4]; // DB  export/import/clipboard ƂɊetB[h؂镶ij
	ColumnPos_t       col        ;
	UInt8             maxFldExpnd; // ҏW̃tB[h̍őgs
	IndexedColorType  clrIdx[2]  ; // ftHg̔wiFCfbNXBsƋs
} TableCalcPref_t; //ver 01b


//===== Each Row Info ======================================================
typedef enum { EE_NONE=0, 
							 EE_DEEP_NESTING=1,  EE_PAREN_NOT_MATCH=2,  EE_NOT_A_NUMBER=3,  EE_NULL_FOUND=4, EE_EXCESS_CHARACTERS=5, 
							 EE_VAR_UNDEFINED=6, EE_RecursiveRef=7   ,  EE_SyntaxErr=8   ,  EE_DivByZero=9 , 
							 EE_DeepEvalNest=11, EE_NullInput=12   ,  EE_DeepRefPage=13,
							 EE_Unexpected01=21, EE_Unexpected02=22,  EE_Unexpected03=23, EE_Unexpected04=24, EE_Unexpected05=25, 
							 EE_Unexpected06=26, EE_Unexpected07=27,  EE_Unexpected08=28,
							 EE_FailToFindVarInDB1=31, EE_FailToFindVarInDB2=32, 
							 EE_NoHeapMem=41, EE_DbErr=42,
							 EE_NotEval=127
} ExprEvalErr_t; //8bit,MAX=255

#define OtherPageVar (MaxDispRow+0) // use as dependsOn[OtherPageVar] // Expr depends on other page var
#define NestedPages  (MaxDispRow+1) // use as dependsOn[NestedPages]  // Expr depends on other page var AND that var also depends on yet another page var
#define MaxDependsOn (MaxDispRow+2)

typedef union {
	struct {
		Boolean notEditable:1 ;
		Boolean notVisible :1 ;
		Boolean useOwnColor:1 ; // Pref ̃ftHgJ[ł͂Ȃ TableCalcRow_t  clrIdx g
		UInt32  reserved   :30;
	}       is;
	UInt32 all;
} RowAttrb_t;

typedef struct {
	RowAttrb_t       rAtrb ; 
	Boolean          dependsOn[MaxDependsOn];
	Char             name[MaxLen_Name];
	Char             expr[MaxLen_Expr];
	double           ansVal;
	ExprEvalErr_t    ansErr;
	AnswerFormat_t   ansFmt;
	UInt8            ansDig; 
	UInt8            rowHgt; //ꍀڂ̕\s //gp
	IndexedColorType clrIdx; //wiF̃CfbNX
	UInt16           top   ; //es̏[W
} TableCalcRow_t;

//===== Each Page(Record) Info ======================================================
typedef enum { TDM_1x10=0, TDM_2x5=1, TDM_4_1x6=3, TDM_2x3_1x4=4 } TableDispMode_t;
typedef enum { KR_NONE=0, KR_FULL=1, KR_HoldOnly=2 } KeyReplaceMode_t;

typedef union {
	struct {
		Boolean UnitDegree:1;
		Boolean localVar  :1; //Yy[W̕ϐ͑Sđ̃y[WQƂȂBႤy[WȂ瓯ϐg
		UInt32  reserved:30;
	}       is;
	UInt32 all;
} PageAttrb_t;

typedef struct {
	PageAttrb_t     pAtrb;
	Char            title[MaxLenTitle];
	TableCalcRow_t  row[MaxDispRow];
	ColumnPos_t     col;
	AnswerFormat_t  ansFmt;
	UInt8           ansDig;
	TableDispMode_t dispMode;
} TableCalc_Record_t;

//===== Running App Global Info ======================================================
typedef struct {
	TableCalcPref_t      cPref;
	UInt16               nDbRecords;  // f[^ƂĕێĂy[WB f[^ = nDbRecords * MaxDispRow
	TableCalc_Record_t*  pPage;       // ݂̃y[Wf[^̃obt@By[Wԍ cPref.cDispPage (gP->cPref.cDispPage) ɕێ
	MemHandle            mhMhName;    // TableCalc.c::findNameInHtcDB() őS DB ̕ϐꗗ擾ێĂobt@
	UInt32               szNameTable; // mhMhName ̗vf
	Boolean              isAnsDispUpToDate[MaxDispRow];
	Char                 bufUndoExpr[MaxLen_Expr];
	KeyReplaceMode_t     keyRepMode;
	Int16                cFocusFldRow;
} MyGlobals_t;


//ȉCꂼ *.h Ƃĕق낤ǖʓ|
//=== TableCalc.c =====================================================================
void savePref_TableCalc(TableCalcPref_t* pPref) MSEG2; 
void loadPref_TableCalc(TableCalcPref_t* pPref) MSEG2;

Int16 findNameInHtcDB(Char *sStr);      
Int16 findNameInHtcDB_ReadOnly(MyGlobals_t* gP, Char *sStr);
Int16 getListOfPageTitle_MemPtrNew(Char ***strPageTitles, Boolean isPrintLocalPage);
                             
typedef enum { DB_ErrNone=0, 
							 DBS_NullPtr=1, DBS_CreateErr=2, DBS_OpenErr=3, DBS_WriteErr=4, DBS_GetRecErr=5, DBS_ExErr=6,
							 DBL_NullPtr=7, DBL_NotFreePtr=8, DBL_ExeedRecNo=9, DBL_MemPtrNewErr=10, DBL_MemMoveErr=11, DBL_NoDB=12,
							 DBA_MaxPagesOver=13, 
							 DBD_MinPageNum=14, DBD_NoPage=15, DBD_DelRecErr=16
} DBErr_t;

DBErr_t addNewRecord(UInt16 newRecPos) MSEG2;                             
DBErr_t delOneRecord(UInt16 delRecPos) MSEG2;                             
DBErr_t saveOneRecord(UInt16 cSavePage, TableCalc_Record_t* pPage); 
DBErr_t loadOneRecord(UInt16 cLoadPage, TableCalc_Record_t* pPage); 

Boolean exportOneRecordHtcDBtoMemoDB(UInt16 htcRecNo) MSEG2;

MyGlobals_t*   getMyGlobals(void);            //̃ZOgɈړȂ    
void         clearMyGlobals(MyGlobals_t* gP); //̃ZOgɈړȂ                    


//=== TableCalc_Form.c =====================================================================
//typedef enum { FM_NotModified, FM_MODIFIED, FM_SelAll, FM_Paste, FM_Copy, FM_Cut } OnFieldFunc_t;
typedef enum { FM_NotModified, FM_MODIFIED, FM_OpenEditExprWin } OnFieldFunc_t;
OnFieldFunc_t fldIns_VarName_LstPopupList(MyGlobals_t* gP, FormType *pCurForm, UInt16 cFdID, UInt16 cLsNameID,
																					                                                   UInt16 cLsPageID, Coord posX, Coord posY) MSEG2;
OnFieldFunc_t fldIns_FuncAll_LstPopupList(MyGlobals_t* gP, FormType *pCurForm, UInt16 cFdID, UInt16 cLsFuncID, Coord posX, Coord posY) MSEG2;
OnFieldFunc_t fldIns_Symbol__LstPopupList(MyGlobals_t* gP, FormType *pCurForm, UInt16 cFdID, UInt16 cLsSymbID, Coord posX, Coord posY) MSEG2;

void execForm(UInt16 cmd); 


//=== TableCalc_Format.c =====================================================================
void formatResult(double cVal, ExprEvalErr_t cErr,                                             //IN 
									AnswerFormat_t cAnsFmt, int cMaxAnsDigit, Boolean isShowPrfx, UInt16 widPix, //IN 
									char* strRet); //Char strRet[MaxAnswerLen];Ƃė̈mۍς݂ł邱      //OUT 


//=== TableCalc_EvalExpr.c =====================================================================
void setDeg(void) MSEG3;
void setRad(void) MSEG3;
Boolean compword(char* wordA, char* wordB, unsigned int cPosA) MSEG3;
ExprEvalErr_t evalExprs(char* exprs, double* result, Boolean *pDependsOn, unsigned int cExprNo) MSEG3;

typedef enum { FT_EOL=0, FT_NORM=1, FT_DivAU=2, FT_MulAU=3 } FunctionType_t;

#define MaxFuncNameLen 8

typedef struct {
	char name[MaxFuncNameLen];
	double (*pfunc)(double x, double y, double z);
	FunctionType_t funcType;
} Func3ArgInfo_t;

typedef struct {
	char name[MaxFuncNameLen];
	double (*pfunc)(double x, double y);
	FunctionType_t funcType;
} Func2ArgInfo_t;

typedef struct {
	char name[MaxFuncNameLen];
	double (*pfunc)(double x);
	FunctionType_t funcType;
} Func1ArgInfo_t;

extern const Func3ArgInfo_t func3Lst[];
extern const Func2ArgInfo_t func2Lst[];
extern const Func1ArgInfo_t func1Lst[];


//=== TableCalc_SolveDepend.c =================================================================
void buf_Expr2Ans(UInt16 cRow, MyGlobals_t* gP, Boolean toBeEval) MSEG3;


//=== TableCalc_Format.c =====================================================================
void SetThausandSeparator(char s1, char s2);
int  ConvertDblToStr(double x, char* s, int format, int digit);


//=== TableCalc_Form_Config.c ================================================================
Boolean myHandleEventForm_ConfCol( EventPtr event) MSEG2;
Boolean myHandleEventForm_ConfGlob(EventPtr event) MSEG2;

//=== TableCalc_Form_EditExpr.c ==============================================================
Boolean myHandleEventForm_EditExpr(EventPtr event) MSEG2;


//================ ` KeyDownEvent modifiers ======================================
#ifndef __HAL_KatteKeyDef__
#define __HAL_KatteKeyDef__
//#define genByHalLDAMask    0x8000 //CMDSPC_KeyDnUp ŔsCxg Assistant ɂN}邽
// modifiers
//SysEvent.h // keyDownEvent modifers
//#define shiftKeyMask       0x0001
//#define capsLockMask       0x0002
//#define numLockMask        0x0004
//#define commandKeyMask     0x0008
//#define optionKeyMask      0x0010
//#define controlKeyMask     0x0020
//#define autoRepeatKeyMask  0x0040      // True if generated due to auto-repeat
//#define doubleTapKeyMask   0x0080      // True if this is a double-tap event
//#define poweredOnKeyMask   0x0100      // True if this is a double-tap event
//#define appEvtHookKeyMask  0x0200      // True if this is an app hook key
//#define libEvtHookKeyMask  0x0400      // True if this is a library hook key
//#define willSendUpKeyMask  0x0800      // True if a keyUp event will be sent later

//================ CLIE SDK 
#define vchrJogUp          0x1700
#define vchrJogDown        0x1701
#define vchrJogPressRepeat 0x1702
#define vchrJogPageUp      0x1703
#define vchrJogPageDown    0x1704
#define vchrJogPress       0x1705
#define vchrJogRelease     0x1706

//===== Treo 700p @ŒׂL[R[hB{̖O͒mȂB
#define vchrTreoGreen   0x021A
#define vchrTreoRed     0x0208 //== vchrHardPower ==hardPowerChr
#define vchrTreoVolUp   0x161B
#define vchrTreoVolDown 0x161C
#define vchrTreoSide    0x161F
#define vchrTreoAlt     0x1609
#define vchrTreoDim     0x1620
#define vchrKeyGuard    0x1619

//===== PBInline ̐؂ւL[R[hB
#define vchrPBTgl 0x00F2

#ifndef ForWristPDA 
#  define MyVChrSoftLeft  0x190A //KB̃L[ƏdȂĂƍB
#  define MyVChrSoftRight 0x190B //Ƃ肠C[J蓖ăL[͈͂̓CFossil p̃L[R[hq
#  define MyVChrHoldAlt   0x190C // Alt
#  define MyVChrHoldSpc   0x190D // Space
#  define MyVChrCmdBarDmy 0x190E //
#  define MyVChrEdExprWin 0x190F // ҏWJL[R[h
#endif

#endif //#ifndef __HAL_KatteKeyDef__
#endif //#ifndef __RSC__
#endif //#ifndef __HalTableCalc_H__

